library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;
use ieee.math_real.all;

entity p16_fir_pipeline_bench is
end p16_fir_pipeline_bench;

architecture Behavioral of p16_fir_pipeline_bench is

component p16_fir_pipeline is port(
	clk : in std_logic;
	data_in : in std_logic_vector(11 downto 0); -- 12 Bit unsigned
	data_out : out std_logic_vector(11 downto 0));
end component;

signal clk : std_logic:='0';
signal data_in : std_logic_vector(11 downto 0):=(others => '0');
signal data_out : std_logic_vector(11 downto 0):=(others => '0');

type rom128x12 is array (0 to 127) of signed(11 downto 0); 
signal sinus_rom : rom128x12;

signal counter: unsigned(6 downto 0):=(others => '0');
signal samplecounter: unsigned(6 downto 0):=(others => '0');
signal speed: unsigned(5 downto 0):="000001";

begin

tabel : for I in 0 to 127 generate
	sinus_rom(I) <= to_signed(integer(sin(2.0*MATH_PI*(real(I)+0.5)/128.0)*2047.5),12);
end generate;

uut: p16_fir_pipeline port map(
	clk => clk,
	data_in => data_in, -- 12 Bit unsigned
	data_out => data_out);

clk <= not clk after 5 ns;

process begin
	wait until rising_edge(clk);
	samplecounter <= samplecounter +1;
	counter <= counter + speed;
	if samplecounter = 127 then
		speed <= speed+1;
	end if;
	data_in <= std_logic_vector(unsigned(sinus_rom(to_integer(counter)) + 2**11)); --unsigned
	if speed = 63 and samplecounter = 127 then
		wait;
	end if;
end process;

end Behavioral;